<?php
	// DISPLAY ERRORS BUT HIDE NOTICES
	error_reporting(E_ALL ^ E_NOTICE);

	// SET HEADERS TO PREVENT BROWSER CACHING OF PAGES
	@header('Expires: Mon, 20 Jul 2000 05:00:00 GMT');
	@header('Last-Modified: '. gmdate('D, d M Y H:i:s') .' GMT');
	@header('Cache-Control: no-store, no-cache, must-revalidate');
	@header('Cache-Control: post-check=0, pre-check=0', false);
	@header('Pragma: no-cache');

	include('includes/mg2_functions.php');
	$mg2 = new mg2db;

	// DISPLAY ADMIN HEADER
	$mg2->adminfolder	 = 'skins/admin/';
	$mg2->gallerytitle = 'Update to kh_mod 0.1.0 final';
	@include($mg2->adminfolder .'admin_header.php');
?>

	<table class="table_menu" cellpadding="0" cellspacing="0">
	<tr valign="top">
		<td align="center" colspan="4">
			<p><strong>Update for MG2 0.5.1 or kh_mod 0.1.0 b2</strong></p>
			<p>This script will update your gallery to kh_mod 0.1.0 final.</p>
			<br />

<?php
	@rmdir('pictures/x');
	if (@mkdir('pictures/x')) {
		@rmdir('pictures/x');
	} else {
		echo '
			ERROR: Cannot write to \'pictures\' folder. Chmod
			\'pictures\' to 777 before continuing!<br />&nbsp;
			</td></tr></table></body></html>
		';
		exit();
	}

	if (is_readable('mg2_settings.php') && include('mg2_settings.php')) {
		if ($mg2->password !== md5(strrev(md5($_REQUEST['password']))))
			inputpassword($mg2);

		if (!isset($mg2->foldersort))	$mg2->foldersort  = "1";				// sort by filename
		if (!isset($mg2->displayfile))$mg2->displayfile = "0";				// display filename under thumbs
		if (!isset($mg2->thumbwidth))	$mg2->thumbwidth  = "150";				// thumb max. width
		if (!isset($mg2->thumbheight))$mg2->thumbheight = "150";				// thumb max. height
		if (!isset($mg2->imagefolder))$mg2->imagefolder = "pictures";		// image folder
		if (!isset($mg2->navtype))		$mg2->navtype		= "0";				// navigationstyp (Text, Icons, Thumbs)
		if (!isset($mg2->commentsets))$mg2->commentsets = "7";				// comment settings
		if (!isset($mg2->accesstime))	$mg2->accesstime	= "15";				// auto logout after 15 min.
		if (!isset($mg2->extendedset))$mg2->extendedset	= "12";				// extended settings
		if (!isset($mg2->introwidth))	$mg2->introwidth	= "0";				// width of folder intro text

		// UPDATE FOR CALENDAR, kh_mod, 0.1.0 b3
		$ext = (int)$mg2->extendedset; $ext |= 16;
		$mg2->extendedset = (string)$ext;

		// UPDATE FOR DATE FORMAT, kh_mod, 0.1.0 b3
		@preg_replace('/%/','',$mg2->dateformat,-1,$number);
		if ($number < 3) {
			$search  = array('%','M','j','i','n','a','A','D');
			$replace = array('','b','e','M','m','p','p','a');
			$mg2->dateformat = str_replace($search,$replace,$mg2->dateformat);
			$mg2->dateformat = @preg_replace('/([abdemMHpyY])/','%$1',$mg2->dateformat);
		}

		$filebuffer = "<?php\n";
		$filebuffer.= '$mg2->gallerytitle = '.chr(34).$mg2->gallerytitle.chr(34).";\n";
		$filebuffer.= '$mg2->adminemail = '.chr(34).$mg2->adminemail.chr(34).";\n";
		$filebuffer.= '$mg2->defaultlang = '.chr(34).$mg2->defaultlang.chr(34).";\n";
		$filebuffer.= '$mg2->activeskin = '.chr(34).$mg2->activeskin.chr(34).";\n";
		$filebuffer.= '$mg2->dateformat = '.chr(34).$mg2->dateformat.chr(34).";\n";
		$filebuffer.= '$mg2->navtype = '.chr(34).$mg2->navtype.chr(34).";\n";
		$filebuffer.= '$mg2->foldersort = '.chr(34).$mg2->foldersort.chr(34).";\n";
		$filebuffer.= '$mg2->foldericons = '.chr(34).$mg2->foldericons.chr(34).";\n";
		$filebuffer.= '$mg2->displayfile = '.chr(34).$mg2->displayfile.chr(34).";\n";
		$filebuffer.= '$mg2->showexif = '.chr(34).$mg2->showexif.chr(34).";\n";
		$filebuffer.= '$mg2->marknew = '.chr(34).$mg2->marknew.chr(34).";\n";
		$filebuffer.= '$mg2->copyright = '.chr(34).$mg2->copyright.chr(34).";\n";
		$filebuffer.= '$mg2->password = '.chr(34).$mg2->password.chr(34).";\n";
		$filebuffer.= '$mg2->extensions = '.chr(34).$mg2->extensions.chr(34).";\n";
		$filebuffer.= '$mg2->mediumimage = '.chr(34).$mg2->mediumimage.chr(34).";\n";
		$filebuffer.= '$mg2->introwidth = '.chr(34).$mg2->introwidth.chr(34).";\n";
		$filebuffer.= '$mg2->indexfile = '.chr(34).$mg2->indexfile.chr(34).";\n";
		$filebuffer.= '$mg2->imagefolder = '.chr(34).$mg2->imagefolder.chr(34).";\n";
		$filebuffer.= '$mg2->thumbquality = '.chr(34).$mg2->thumbquality.chr(34).";\n";
		$filebuffer.= '$mg2->thumbwidth = '.chr(34).$mg2->thumbwidth.chr(34).";\n";
		$filebuffer.= '$mg2->thumbheight = '.chr(34).$mg2->thumbheight.chr(34).";\n";
		$filebuffer.= '$mg2->commentsets = '.chr(34).$mg2->commentsets.chr(34).";\n";
		$filebuffer.= '$mg2->imagecolumns = '.chr(34).$mg2->imagecolumns.chr(34).";\n";
		$filebuffer.= '$mg2->imagerows = '.chr(34).$mg2->imagerows.chr(34).";\n";
		$filebuffer.= '$mg2->slideshowdelay = '.chr(34).$mg2->slideshowdelay.chr(34).";\n";
		$filebuffer.= '$mg2->websitelink = '.chr(34).$mg2->websitelink.chr(34).";\n";
		$filebuffer.= '$mg2->websitetext = '.chr(34).$mg2->websitetext.chr(34).";\n";
		$filebuffer.= '$mg2->accesstime = '.chr(34).$mg2->accesstime.chr(34).";\n";
		$filebuffer.= '$mg2->extendedset = '.chr(34).$mg2->extendedset.chr(34).";\n";
		$filebuffer.= '$mg2->installdate = '.chr(34).$mg2->installdate.chr(34).";\n";
		$filebuffer.= '?>';
		$fd = fopen('mg2_settings.php','w+');
		$update_ok = fwrite($fd,$filebuffer);
		fclose($fd);

		echo ($update_ok)?
			'Your gallery should now be upgraded to 0.5.1 (kh_mod 0.1.0 final)<br />
			 - IMPORTANT: DELETE \'mg2_update.php\' USING FTP NOW!!!<br />&nbsp;
			<br />
			<p><a href="admin.php">Go to admin panel</a></p>'
			:
			'Couldn\'t upgrade your MG2 installation to 0.5.1 (kh_mod 0.1.0 final)!
			<br />
			<p><a href="mg2_update.php">Try again</a></p>';
	} else {
		echo '
			ERROR: Cannot read \'mg2_settings.php\' to update your MG2 installation!
			<br />&nbsp;
		';
	}
?>
		</td>
	</tr>
</table>
</body>
</html>

<?php
	function inputpassword($mg2) {
		if (!is_readable('lang/'.$mg2->defaultlang))	$mg2->defaultlang = 'english.php';
		if (is_readable('lang/'.$mg2->defaultlang)) {
			include('lang/'.$mg2->defaultlang);
			@header('Content-Type: text/html; charset='.$mg2->charset);
		}

		echo'
		<table class="table_menu" cellpadding="0" cellspacing="0">
			<tr>
			<td class="td_div">
				<br />
				<form name="login" method="post" action="'.$PHP_SELF.'">
				<p><b>'. $mg2->lang['enterpassword'] .'</b></p>
				<p>'. $mg2->lang['thissection'] .'</p>
				<p><input type="password" name="password" class="admintext" /></p>
				<p><input type="image" src="'. $mg2->adminfolder .'images/ok.gif" class="adminpicbutton" alt="'. $mg2->lang['ok'] .'" title="'. $mg2->lang['ok'] .'" /></p>
				</form>
			</td>
		</tr>
		</table>
		</body>
		</html>
		';
		exit();
	}
?>